console.log('This site was generated by Hugo.');

// Load jQuery from NPM
import $, { ajax } from 'js/jquery/jquery';
import _ from 'js/lodash/lodash';

import * as config from '@params';

const CODE_HISTORY_KEY = `CODE_HISTORY_${config.title}`;

window.jQuery = $;
window.$ = $;

const apiEndpoint = `https://api.${config.baseDomain}/api`;
let codeHistory = [];

function getCodeLink(code) {
  return `https://app.${config.baseDomain}/challenges/${code}/preview`;
}
let codeLinkHandler;

function renderHistory() {
  const codeList = $('#codeHistoryList');
  const codeListParent = codeList.parent();
  codeListParent.addClass('d-none');
  codeList.empty();

  codeHistory.forEach((code) => {
    const codeLink = $(`<a href="${getCodeLink(code)}" target="_blank" class="link-light code-link" data-code="${code}">${code}</a>`);
    codeLink.on('click', codeLinkHandler);
    const codeListItem = $('<li class="list-group-item bg-primary"/></li>').append(codeLink);
    codeList.append(codeListItem);
  });
  $('#codeHistoryLength').html(`${codeHistory.length}/${config.code_history_max_length}`);

  codeListParent.toggleClass('d-none', codeHistory.length === 0);
}

function processCode(code) {
  if (!code) {
    return;
  }
  let filteredCodeHistory = _.reject(codeHistory, (c) => c === code);
  if (filteredCodeHistory.length === config.code_history_max_lengthS) {
    filteredCodeHistory = filteredCodeHistory.slice(0, -1);
  }
  codeHistory = _.concat(
    [code],
    filteredCodeHistory,
  );
  localStorage.setItem(CODE_HISTORY_KEY, JSON.stringify(codeHistory));
  window.open(getCodeLink(code), '_blank');
  renderHistory();
  $('#previewQuestionCode').val('');
}

codeLinkHandler = (e) => {
  e.preventDefault();
  const code = $(e.target).data('code');
  processCode(code);
};

$(() => {
  codeHistory = JSON.parse(localStorage.getItem(CODE_HISTORY_KEY) || '[]');
  renderHistory();

  ajax({
    url: apiEndpoint,
    success: (res) => {
      $('#footer_version').html(res.version);
    },
  });

  $('#previewForm').on('submit', (e) => {
    e.preventDefault();
    const code = $('#previewQuestionCode').val().trim();
    processCode(code);
  });

  $('#clearButton').on('click', (e) => {
    e.preventDefault();
    codeHistory = [];
    localStorage.removeItem(CODE_HISTORY_KEY);
    renderHistory();
    $('#previewQuestionCode').val('');
  });
});